      program proc
      implicit none
      integer nargs
      character fname*80
      common / files / fname
      integer  IARGC
      external IARGC

      nargs = IARGC()
      if (nargs .lt. 1) then
         print *, 'need input file name'
         call EXIT(9)
      else
         call GETARG(1, fname)
      endif

      print *, '===== NORME:'
      call prterr('NORME', '2', '2')
      print *, '===== NORMS:'
      call prterr('NORMS', '2', '2')
      print *, '===== NORMO:'
      call prterr('NORMO', '2', '2')
      print *, '===== DIFF:'
      call prtdif('2', '2')

      print *, '===== NORME:'
      call prterr('NORME', '2', '1')
      print *, '===== NORMS:'
      call prterr('NORMS', '2', '1')
      print *, '===== NORMO:'
      call prterr('NORMO', '2', '1')
      print *, '===== DIFF:'
      call prtdif('2', '1')

      print *, '===== NORME:'
      call prterr('NORME', '3', '2')
      print *, '===== NORMS:'
      call prterr('NORMS', '3', '2')
      print *, '===== NORMO:'
      call prterr('NORMO', '3', '2')
      print *, '===== DIFF:'
      call prtdif('3', '2')

      print *, '===== NORME:'
      call prterr('NORME', '3', '1')
      print *, '===== NORMS:'
      call prterr('NORMS', '3', '1')
      print *, '===== NORMO:'
      call prterr('NORMO', '3', '1')
      print *, '===== DIFF:'
      call prtdif('3', '1')

      stop
      end

c======================================================
      subroutine prterr(pref, dim, deg)
      implicit none
      character*5 pref
      character*1 dim, deg

      call prt(pref, dim, deg, '\\')
      print *, '\\hline'
      call prt(pref, dim, deg, '1')
      print *, '\\hline'
      call prt(pref, dim, deg, '2')

      return
      end

      
c======================================================
      subroutine prtdif(dim, deg)
      implicit none
      character*5 pref
      character*1 dim, deg

      pref = 'NORMD'
      call prtd(pref, dim, deg, '\\')
      print *, '\\hline'
      call prtd(pref, dim, deg, '1')
      print *, '\\hline'
      call prtd(pref, dim, deg, '2')

      return
      end

      
c======================================================
      subroutine prt(pref, dim, deg, norm)
      implicit none
      character*5 pref
      character*1 dim, deg, norm, cr
      character*90 str, s
      integer icr, lens
c     cr is ^M
      character fname*80
      common / files / fname
      data  cr / 13 /

      open (unit=2, file=fname, status='old')
 10   continue
      str = ''

      read (2,120,end=20) str
 120  format(a)
      icr = index(str, cr)
      if (icr .gt. 0) then
         s = str(1:icr-1)
         lens = icr-1
      else
         s = str
         lens = len(s)
      endif

      if (s(1:5) .eq. pref) then
         if (s(7:7) .eq. dim) then
            if (s(11:11) .eq. deg) then
               if (s(18:18) .eq. norm) then
                  print *, s(7:lens)
               endif
            endif
         endif
      endif

      go to 10
 20   continue
      close (unit=2)

      return
      end


c======================================================
      subroutine prtd(pref, dim, deg, norm)
      implicit none
      character*5 pref
      character*1 dim, deg, norm, cr
      character*90 str, s, keep(40), keeps
      character*23 prefx
      character*4 inth, char4
      integer icr, nkeep, i, hinv(40)
      integer nknew, hinvn(40)
      double precision d2hh(40), d4h2h(40), dblbl
      double precision d2hhn(40), d4h2hn(40), p(40)
      external dblbl
      external char4
c     cr is ^M
      character fname*80
      common / files / fname
      data  cr / 13 /

      nkeep = 0

      open (unit=2, file=fname, status='old')
 10   continue
      str = ''

      read (2,120,end=20) str
 120  format(a)
      icr = index(str, cr)
      if (icr .gt. 0) then
         s = str(1:icr-1)
      else
         s = str
      endif

      if (s(1:5) .eq. pref) then
         if (s(7:7) .eq. dim) then
            if (s(11:11) .eq. deg) then
               if (s(18:18) .eq. norm) then
                  nkeep = nkeep + 1
                  keep(nkeep) = s(7:)
               endif
            endif
         endif
      endif

      go to 10
 20   continue
      close (unit=2)

      do i = 1, nkeep
         keeps = keep(i)
c         print *, keeps
c     get hinv, d2hh d4h2h
         read (keeps(24:28), 130) hinv(i)
 130     format (bn, i4)
c         print *, hinv(i)
         d2hh(i) = dblbl(keeps(30:42))
         d4h2h(i) = dblbl(keeps(44:56))
c         print *, d2hh(i)
c         print *, d4h2h(i)
      enddo

      call sortem(nkeep, hinv, d2hh, d4h2h,
     &     nknew, hinvn, d2hhn, d4h2hn, p)

c     print out
      prefx = keep(1)
      prefx = prefx(1:23)

      do i = 1, nknew
         inth = char4(hinvn(i))
         print 140, prefx, inth, d2hhn(i), d4h2hn(i), p(i)          
 140     format (1x, a, a4, ' &', 1PE12.5, ' &', 1PE12.5, ' & ',
     &        0PF5.2, ' \\\\ \\hline')
      enddo

      return
      end

c======================================================
      double precision function dblbl(str)
      implicit none
      character*13 str, blk13

      blk13 = '             '
      if (str .eq. blk13) then
         dblbl = 0.
      else
         read (str, *) dblbl
      endif
         
      return
      end


c======================================================
      subroutine sortem(nkeep, hinv, d2hh, d4h2h,
     &     nknew, hinvn, d2hhn, d4h2hn, p)
      implicit none
      integer nkeep, hinv(nkeep), hinvn(nkeep), i, j, nknew
      double precision d2hh(nkeep), d4h2h(nkeep)
      double precision d2hhn(nkeep), d4h2hn(nkeep), p(nkeep)
      double precision invln2

      invln2 = 1d0 / log(2d0)
      nknew = 0
      do i = 1, nkeep
         do j = 1, nkeep

            if (i .ne. j) then
               if (hinv(i) .eq. hinv(j)) then
                  if ((d2hh(i) .ne. 0.0) .and.
     &                 (d4h2h(j) .ne. 0.0)) then
                     nknew = nknew + 1
                     hinvn(nknew) = hinv(i)
                     d2hhn(nknew) = d2hh(i)
                     d4h2hn(nknew) = d4h2h(j)
                     p(nknew) = invln2 *
     &                    log(d4h2hn(nknew) / d2hhn(nknew))
                  endif
               endif
            endif

         enddo
      enddo

      return
      end


c======================================================
      character*4 function char4(i)
      implicit none
      integer i

      if (i .lt. 10) then
 1       format (i1, 3x)
         write (char4, 1) i
      elseif (i .lt. 100) then
 2       format (i2, 2x)
         write (char4, 2) i
      elseif (i .lt. 1000) then
 3       format (i3, 1x)
         write (char4, 3) i
      else
 4       format (i4)
         write (char4, 4) i
      endif

      return
      end

