#ifndef _GRADIENTF_F_H_
#define _GRADIENTF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure TWOPTSGRAD ...
//
#define FORT_TWOPTSGRAD FORTRAN_NAME( TWOPTSGRAD ,twoptsgrad )
void 
FORT_TWOPTSGRAD(
      CHFp_FRA1(dphi)
      ,CHFp_CONST_FRA1(phi)
      ,CHFp_CONST_INT(idir)
      ,CHFp_CONST_REAL(dl)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi)
      ,CHFp_BOX(centerBox) );

// Prototype for Fortran procedure TWOPTSSTAGGRAD ...
//
#define FORT_TWOPTSSTAGGRAD FORTRAN_NAME( TWOPTSSTAGGRAD ,twoptsstaggrad )
void 
FORT_TWOPTSSTAGGRAD(
      CHFp_FRA1(dphi)
      ,CHFp_CONST_FRA1(phi)
      ,CHFp_CONST_INT(idir)
      ,CHFp_CONST_REAL(dl)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi)
      ,CHFp_BOX(centerBox) );

// Prototype for Fortran procedure FOURPTSGRAD ...
//
#define FORT_FOURPTSGRAD FORTRAN_NAME( FOURPTSGRAD ,fourptsgrad )
void 
FORT_FOURPTSGRAD(
      CHFp_FRA1(dphi)
      ,CHFp_CONST_FRA1(phi)
      ,CHFp_CONST_INT(idir)
      ,CHFp_CONST_REAL(dl)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi)
      ,CHFp_BOX(centerBox) );

// Prototype for Fortran procedure FOURPTSSTAGGRAD ...
//
#define FORT_FOURPTSSTAGGRAD FORTRAN_NAME( FOURPTSSTAGGRAD ,fourptsstaggrad )
void 
FORT_FOURPTSSTAGGRAD(
      CHFp_FRA1(dphi)
      ,CHFp_CONST_FRA1(phi)
      ,CHFp_CONST_INT(idir)
      ,CHFp_CONST_REAL(dl)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi)
      ,CHFp_BOX(centerBox) );

// Prototype for Fortran procedure TENPTSGRAD ...
//
#define FORT_TENPTSGRAD FORTRAN_NAME( TENPTSGRAD ,tenptsgrad )
void 
FORT_TENPTSGRAD(
      CHFp_FRA1(dphi)
      ,CHFp_CONST_FRA1(phi)
      ,CHFp_CONST_INT(idir)
      ,CHFp_CONST_REAL(dl)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi)
      ,CHFp_BOX(centerBox) );

// Prototype for Fortran procedure TENPTSSTAGGRAD ...
//
#define FORT_TENPTSSTAGGRAD FORTRAN_NAME( TENPTSSTAGGRAD ,tenptsstaggrad )
void 
FORT_TENPTSSTAGGRAD(
      CHFp_FRA1(dphi)
      ,CHFp_CONST_FRA1(phi)
      ,CHFp_CONST_INT(idir)
      ,CHFp_CONST_REAL(dl)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi)
      ,CHFp_BOX(centerBox) );

}

#endif
