#if CH_LANG_CC
/* _______              __
  / ___/ /  ___  __ _  / /  ___
 / /__/ _ \/ _ \/  ' \/ _ \/ _ \
 \___/_//_/\___/_/_/_/_.__/\___/
*/
//
// This software is copyright (C) by the Lawrence Berkeley
// National Laboratory.  Permission is granted to reproduce
// this software for non-commercial purposes provided that
// this notice is left intact.
//
// It is acknowledged that the U.S. Government has rights to
// this software under Contract DE-AC03-765F00098 between
// the U.S.  Department of Energy and the University of
// California.
//
// This software is provided as a professional and academic
// contribution for joint exchange. Thus it is experimental,
// is provided ``as is'', with no warranties of any kind
// whatsoever, no support, no promise of updates, or printed
// documentation. By using this software, you acknowledge
// that the Lawrence Berkeley National Laboratory and
// Regents of the University of California shall have no
// liability with respect to the infringement of other
// copyrights by any part of this software.
//

// Constants used between C++ and Fortran to index the conserved and
// primitive variables and to know the number of each.  Also, the number
// of slopes and fluxes are defined here.
#endif

#ifndef CH_LGINTEGRATOR_H
#define CH_LGINTEGRATOR_H

#define GAS
#define GRAVITY

#undef  INFINITE_DOMAIN_BC

#if (CH_SPACEDIM == 2)

#define WRHO   0
#define WVELX  1
#define WVELY  2
#define WPRES  3
#define WENTR  4

#define WNUM   (5) 
#define WSLOPE (5)

#define URHO  0
#define UMOMX 1
#define UMOMY 2
#define UENG  3
#define UENTR 4

#define UNUM  (5)
#define UFLUX (5)

#define MWAVE 0
#define ZWAVE 1
#define SWAVE 3
#define PWAVE 4

#endif

#if (CH_SPACEDIM == 3)

#define WRHO   0
#define WVELX  1
#define WVELY  2
#define WVELZ  3
#define WPRES  4
#define WENTR  5

#define WNUM   (6)
#define WSLOPE (6)

#define URHO  0
#define UMOMX 1
#define UMOMY 2
#define UMOMZ 3
#define UENG  4
#define UENTR 5

#define UNUM  (6)
#define UFLUX (6)

#define MWAVE 0
#define ZWAVE 1
#define SWAVE 4
#define PWAVE 5

#endif

#endif


