#ifndef _RAMPIBCF_F_H_
#define _RAMPIBCF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure RAMPSETF ...
//
#define FORT_RAMPSETF FORTRAN_NAME( RAMPSETF ,rampsetf )
void 
FORT_RAMPSETF(
      CHFp_REAL(ausmallPressure)
      ,CHFp_CONST_REAL(augamma)
      ,CHFp_CONST_REAL(aualpha)
      ,CHFp_CONST_REAL(aums)
      ,CHFp_CONST_REAL(auxcorner)
      ,CHFp_CONST_REAL(auartvisc)
      ,CHFp_CONST_REAL(auRsTolerance)
      ,CHFp_CONST_INT(aumaxRsIter)
      ,CHFp_CONST_REAL(aumaxMach) );

// Prototype for Fortran procedure RAMPINITF ...
//
#define FORT_RAMPINITF FORTRAN_NAME( RAMPINITF ,rampinitf )
void 
FORT_RAMPINITF(
      CHFp_FRA(U)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure RAMPBCF ...
//
#define FORT_RAMPBCF FORTRAN_NAME( RAMPBCF ,rampbcf )
void 
FORT_RAMPBCF(
      CHFp_FRA(Wgdnv)
      ,CHFp_CONST_FRA(Wextrap)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_REAL(time)
      ,CHFp_CONST_INT(lohisign)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure RAMPSLOPEBCSF ...
//
#define FORT_RAMPSLOPEBCSF FORTRAN_NAME( RAMPSLOPEBCSF ,rampslopebcsf )
void 
FORT_RAMPSLOPEBCSF(
      CHFp_FRA(dW)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi) );

// Prototype for Fortran procedure RAMPARTVISCF ...
//
#define FORT_RAMPARTVISCF FORTRAN_NAME( RAMPARTVISCF ,rampartviscf )
void 
FORT_RAMPARTVISCF(
      CHFp_FRA(F)
      ,CHFp_CONST_FRA(U)
      ,CHFp_CONST_FRA1(divu)
      ,CHFp_CONST_INT(lohisign)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

}

#endif
