#ifndef _SELFGRAVF_F_H_
#define _SELFGRAVF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure SETSELFGRAV ...
//
#define FORT_SETSELFGRAV FORTRAN_NAME( SETSELFGRAV ,setselfgrav )
void 
FORT_SETSELFGRAV(
      CHFp_CONST_REAL(augamma)
      ,CHFp_CONST_REAL(auartvisc)
      ,CHFp_CONST_REAL(auRsTolerance)
      ,CHFp_CONST_REAL(aumaxRsIter)
      ,CHFp_CONST_REAL(aumaxMach) );

// Prototype for Fortran procedure SETFLOORS ...
//
#define FORT_SETFLOORS FORTRAN_NAME( SETFLOORS ,setfloors )
void 
FORT_SETFLOORS(
      CHFp_CONST_REAL(ausmallr0)
      ,CHFp_CONST_REAL(ausmallu0)
      ,CHFp_CONST_REAL(ausmallp0)
      ,CHFp_CONST_REAL(ausmalls0) );

// Prototype for Fortran procedure COMPUTEPRESSUREF ...
//
#define FORT_COMPUTEPRESSUREF FORTRAN_NAME( COMPUTEPRESSUREF ,computepressuref )
void 
FORT_COMPUTEPRESSUREF(
      CHFp_FRA1(PRES)
      ,CHFp_CONST_FRA(U)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure INTERPOLATEINTIME ...
//
#define FORT_INTERPOLATEINTIME FORTRAN_NAME( INTERPOLATEINTIME ,interpolateintime )
void 
FORT_INTERPOLATEINTIME(
      CHFp_FRA(phi)
      ,CHFp_CONST_FRA(phiNew)
      ,CHFp_CONST_FRA(phiOld)
      ,CHFp_CONST_REAL(alpha)
      ,CHFp_CONST_INT(srcComp)
      ,CHFp_CONST_INT(dstComp)
      ,CHFp_CONST_INT(sizeComp)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure COMPUTEPLOTVARS ...
//
#define FORT_COMPUTEPLOTVARS FORTRAN_NAME( COMPUTEPLOTVARS ,computeplotvars )
void 
FORT_COMPUTEPLOTVARS(
      CHFp_FRA(W)
      ,CHFp_CONST_FRA(U)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure GETRELGRADF ...
//
#define FORT_GETRELGRADF FORTRAN_NAME( GETRELGRADF ,getrelgradf )
void 
FORT_GETRELGRADF(
      CHFp_FRA1(du)
      ,CHFp_CONST_FRA1(u)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi)
      ,CHFp_BOX(centerBox) );

// Prototype for Fortran procedure MAGNITUDEF ...
//
#define FORT_MAGNITUDEF FORTRAN_NAME( MAGNITUDEF ,magnitudef )
void 
FORT_MAGNITUDEF(
      CHFp_FRA1(magdata)
      ,CHFp_CONST_FRA(data)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure SHOCKPRESJUMPF ...
//
#define FORT_SHOCKPRESJUMPF FORTRAN_NAME( SHOCKPRESJUMPF ,shockpresjumpf )
void 
FORT_SHOCKPRESJUMPF(
      CHFp_FRA1(pjump)
      ,CHFp_FRA(wrk)
      ,CHFp_CONST_FRA(U)
      ,CHFp_BOX(gbox)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure VORTICITYF ...
//
#define FORT_VORTICITYF FORTRAN_NAME( VORTICITYF ,vorticityf )
void 
FORT_VORTICITYF(
      CHFp_FRA1(vorticity)
      ,CHFp_FRA(wrk)
      ,CHFp_CONST_FRA(U)
      ,CHFp_BOX(gbox)
      ,CHFp_BOX(box) );

}

#endif
