#ifndef _SELFGRAVITYPHYSICSF_F_H_
#define _SELFGRAVITYPHYSICSF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure MAXWAVESPEEDF ...
//
#define FORT_MAXWAVESPEEDF FORTRAN_NAME( MAXWAVESPEEDF ,maxwavespeedf )
void 
FORT_MAXWAVESPEEDF(
      CHFp_REAL(cmax)
      ,CHFp_CONST_FRA(U)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure MAXWAVESPEEDWSOURCEF ...
//
#define FORT_MAXWAVESPEEDWSOURCEF FORTRAN_NAME( MAXWAVESPEEDWSOURCEF ,maxwavespeedwsourcef )
void 
FORT_MAXWAVESPEEDWSOURCEF(
      CHFp_REAL(cmax)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_FRA(srce)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure CONSTOPRIMF ...
//
#define FORT_CONSTOPRIMF FORTRAN_NAME( CONSTOPRIMF ,constoprimf )
void 
FORT_CONSTOPRIMF(
      CHFp_FRA(W)
      ,CHFp_CONST_FRA(U)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure PRIMTOCONSF ...
//
#define FORT_PRIMTOCONSF FORTRAN_NAME( PRIMTOCONSF ,primtoconsf )
void 
FORT_PRIMTOCONSF(
      CHFp_FRA(U)
      ,CHFp_CONST_FRA(W)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure RIEMANNF ...
//
#define FORT_RIEMANNF FORTRAN_NAME( RIEMANNF ,riemannf )
void 
FORT_RIEMANNF(
      CHFp_FRA(Wgdnv)
      ,CHFp_CONST_FRA(WLeft)
      ,CHFp_CONST_FRA(WRight)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure RIEMANNF ...
//
#define FORT_RIEMANNF FORTRAN_NAME( RIEMANNF ,riemannf )
void 
FORT_RIEMANNF(
      CHFp_FRA(Wgdnv)
      ,CHFp_CONST_FRA(WLeft)
      ,CHFp_CONST_FRA(WRight)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure GETFLUXF ...
//
#define FORT_GETFLUXF FORTRAN_NAME( GETFLUXF ,getfluxf )
void 
FORT_GETFLUXF(
      CHFp_FRA(F)
      ,CHFp_CONST_FRA(Wgdnv)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure CHARANALYSISF ...
//
#define FORT_CHARANALYSISF FORTRAN_NAME( CHARANALYSISF ,charanalysisf )
void 
FORT_CHARANALYSISF(
      CHFp_FRA(dW)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_INT(normdir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure CHARSYNTHESISF ...
//
#define FORT_CHARSYNTHESISF FORTRAN_NAME( CHARSYNTHESISF ,charsynthesisf )
void 
FORT_CHARSYNTHESISF(
      CHFp_FRA(dW)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_INT(normdir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure CHARVALUESF ...
//
#define FORT_CHARVALUESF FORTRAN_NAME( CHARVALUESF ,charvaluesf )
void 
FORT_CHARVALUESF(
      CHFp_FRA(lambda)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_INT(normdir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure GETADWDXF ...
//
#define FORT_GETADWDXF FORTRAN_NAME( GETADWDXF ,getadwdxf )
void 
FORT_GETADWDXF(
      CHFp_FRA(adwdx)
      ,CHFp_CONST_FRA(WHalf)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_REAL(scale)
      ,CHFp_CONST_INT(normdir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure POSTNORMALPREDF ...
//
#define FORT_POSTNORMALPREDF FORTRAN_NAME( POSTNORMALPREDF ,postnormalpredf )
void 
FORT_POSTNORMALPREDF(
      CHFp_FRA(dWMinus)
      ,CHFp_FRA(dWPlus)
      ,CHFp_CONST_FRA(W)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure COMPUTESOURCEF ...
//
#define FORT_COMPUTESOURCEF FORTRAN_NAME( COMPUTESOURCEF ,computesourcef )
void 
FORT_COMPUTESOURCEF(
      CHFp_FRA(srce)
      ,CHFp_CONST_FRA(tsrce)
      ,CHFp_CONST_FRA(W)
      ,CHFp_BOX(gbox)
      ,CHFp_BOX(sbox) );

// Prototype for Fortran procedure COMPUTELOCALSOURCEF ...
//
#define FORT_COMPUTELOCALSOURCEF FORTRAN_NAME( COMPUTELOCALSOURCEF ,computelocalsourcef )
void 
FORT_COMPUTELOCALSOURCEF(
      CHFp_FRA(locsrce)
      ,CHFp_CONST_FRA(srce)
      ,CHFp_CONST_FRA(W)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure APPLYSOURCEF ...
//
#define FORT_APPLYSOURCEF FORTRAN_NAME( APPLYSOURCEF ,applysourcef )
void 
FORT_APPLYSOURCEF(
      CHFp_FRA(U)
      ,CHFp_CONST_FRA(src)
      ,CHFp_CONST_REAL(dt)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure APPLYFORCECORRF ...
//
#define FORT_APPLYFORCECORRF FORTRAN_NAME( APPLYFORCECORRF ,applyforcecorrf )
void 
FORT_APPLYFORCECORRF(
      CHFp_FRA(U)
      ,CHFp_CONST_FRA(force)
      ,CHFp_CONST_REAL(dt)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure SYNCHRONIZEF ...
//
#define FORT_SYNCHRONIZEF FORTRAN_NAME( SYNCHRONIZEF ,synchronizef )
void 
FORT_SYNCHRONIZEF(
      CHFp_FRA(U)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure RESETPRESSURE ...
//
#define FORT_RESETPRESSURE FORTRAN_NAME( RESETPRESSURE ,resetpressure )
void 
FORT_RESETPRESSURE(
      CHFp_FRA(U)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure RESETTEMPERATUREF ...
//
#define FORT_RESETTEMPERATUREF FORTRAN_NAME( RESETTEMPERATUREF ,resettemperaturef )
void 
FORT_RESETTEMPERATUREF(
      CHFp_FRA(U)
      ,CHFp_CONST_REAL(tempMin)
      ,CHFp_BOX(box) );

}

#endif
