/*   _______              __
    / ___/ /  ___  __ _  / /  ___
   / /__/ _ \/ _ \/  V \/ _ \/ _ \
   \___/_//_/\___/_/_/_/_.__/\___/
*/
// CHOMBO Copyright (c) 2000-2004, The Regents of the University of
// California, through Lawrence Berkeley National Laboratory (subject to
// receipt of any required approvals from U.S. Dept. of Energy).  All
// rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// (1) Redistributions of source code must retain the above copyright
// notice, this list of conditions and the following disclaimer.
// (2) Redistributions in binary form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
// (3) Neither the name of Lawrence Berkeley National Laboratory, U.S.
// Dept. of Energy nor the names of its contributors may be used to endorse
// or promote products derived from this software without specific prior
// written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
// TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
// PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
// OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// You are under no obligation whatsoever to provide any bug fixes,
// patches, or upgrades to the features, functionality or performance of
// the source code ("Enhancements") to anyone; however, if you choose to
// make your Enhancements available either publicly, or directly to
// Lawrence Berkeley National Laboratory, without imposing a separate
// written license agreement for such Enhancements, then you hereby grant
// the following license: a non-exclusive, royalty-free perpetual license
// to install, use, modify, prepare derivative works, incorporate into
// other computer software, distribute, and sublicense such Enhancements or
// derivative works thereof, in binary and source code form.
//
// TRADEMARKS. Product and company names mentioned herein may be the
// trademarks of their respective owners.  Any rights not expressly granted
// herein are reserved.
//


#ifndef _COUNTER_H_
#define _COUNTER_H_

#define _MAX_LEVELS 3

// INS code 
#define COUNTER_levelSolve_init                ( 0*_MAX_LEVELS + 1)
#define COUNTER_levelSolve_phi                 ( 1*_MAX_LEVELS + 1)
#define COUNTER_levelSolve_pi                  ( 2*_MAX_LEVELS + 1)
#define COUNTER_levelSolve_viscous1            ( 3*_MAX_LEVELS + 1)
#define COUNTER_levelSolve_viscous2            ( 4*_MAX_LEVELS + 1)
#define COUNTER_levelSolve_ustarinit1          ( 5*_MAX_LEVELS + 1)
#define COUNTER_levelSolve_ustarinit2          ( 6*_MAX_LEVELS + 1)
#define COUNTER_levelSolve_ustar1              ( 7*_MAX_LEVELS + 1)
#define COUNTER_levelSolve_ustar2              ( 8*_MAX_LEVELS + 1)

// diffusion TGA solver (for VCR)
#define COUNTER_levelSolve_TGA1                ( 9*_MAX_LEVELS + 1)
#define COUNTER_levelSolve_TGA2                (10*_MAX_LEVELS + 1)

#define COUNTER_levelSolveH                    (11*_MAX_LEVELS + 1)

#define COUNTER_solveAMR_INSinit               (12*_MAX_LEVELS + 1)
#define COUNTER_solveAMR_smoothVelField        (13*_MAX_LEVELS + 1)
#define COUNTER_solveAMR_smoothVelFieldScalars (14*_MAX_LEVELS + 1)
#define COUNTER_solveAMR_diffusion             (15*_MAX_LEVELS + 1)
#define COUNTER_solveAMR_viscous               (16*_MAX_LEVELS + 1)
#define COUNTER_solveAMR_syncProjection        (17*_MAX_LEVELS + 1)
#define COUNTER_solveAMR_VDCorrection          (18*_MAX_LEVELS + 1)
#define COUNTER_solveAMR_initVelProj           (19*_MAX_LEVELS + 1)

// INS particle code -- new stuff
#define COUNTER_solveAMR_MacProject            (20*_MAX_LEVELS + 1)
#define COUNTER_solveAMR_CCProject             (21*_MAX_LEVELS + 1)
#define COUNTER_solveAMR_initData              (22*_MAX_LEVELS + 1)
#define COUNTER_solveAMR_updatePPos            (23*_MAX_LEVELS + 1)
#define COUNTER_solveAMR_initPressure          (24*_MAX_LEVELS + 1)
// AMRParticleProjector.cpp
#define COUNTER_solveAMR_projectedForce        (25*_MAX_LEVELS + 1)

#define COUNTER_bottomSmoother_Helmholtz       (26*_MAX_LEVELS + 1)
#define COUNTER_bottomSmoother_Poisson         (27*_MAX_LEVELS + 1)



#define MAX_ITERATION_COUNTERS (28*_MAX_LEVELS + 1)

#include <string>
// global variables
extern int IterationFlavor;
extern int BIterationFlavor;

struct CounterStruct {
  //std::string Name;
  char Name[50];
  int Count;
  int Value;
  int NmaxIteration;
  double wc;
};
extern CounterStruct NoelsSooperIterationCounter[MAX_ITERATION_COUNTERS];

extern int GlobalLevel;

#define NPEX 500000 // temporary testing

#endif
