
#ifndef _NEUMANNRZFUNCTIONF_H_
#define _NEUMANNRZFUNCTIONF_H_

#include "BaseBCVectValue.H"
#include "Forcing.H"

class NeumannRZFunctionF : public BaseBCVectValue
{
  Forcing* m_forcing;
public:
  Vector<Real> get_value(  const RealVect& a_point, const Real& a_time, const RealVect& a_normal );
/// x-derivatives of function values at a point and a time
  Vector<Real> get_xderivatives(const RealVect& a_point, const Real a_time=0.0 );

/// y-derivatives of function values at a point and a time
  Vector<Real> get_yderivatives(const RealVect& a_point, const Real a_time=0.0 );

/// z-derivatives of function values at a point and a time
  Vector<Real> get_zderivatives(const RealVect& a_point, const Real a_time=0.0 );
};

#endif
