#include "NeumannRZFunctionF.H"

Vector<Real> NeumannRZFunctionF::get_value( const RealVect& a_point, const Real& a_t,
		           	            const RealVect& a_normal )
{
   Vector<Real> dT = m_forcing->get_gradT( a_point, a_t );
   Vector<Real> retval(1,0.0);
   for( int d=0; d<SpaceDim; d++ )
     retval[0] += a_normal[d]*dT[d];
   return retval;
}

/// x-derivatives of function values at a point and a time
Vector<Real> get_xderivatives(const RealVect& a_point, const Real a_time )
{ Vector<Real> retval(1,0.0); return retval;}

/// y-derivatives of function values at a point and a time
Vector<Real> get_yderivatives(const RealVect& a_point, const Real a_time )
{ Vector<Real> retval(1,0.0); return retval;}

/// z-derivatives of function values at a point and a time
Vector<Real> get_zderivatives(const RealVect& a_point, const Real a_time )
{ Vector<Real> retval(1,0.0); return retval;}
