#ifndef _VCDIVOPF_F_H_
#define _VCDIVOPF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure VCDIVOP2LOPHIADD ...
//
#define FORT_VCDIVOP2LOPHIADD FORTRAN_NAME( VCDIVOP2LOPHIADD ,vcdivop2lophiadd )
void 
FORT_VCDIVOP2LOPHIADD(
      CHFp_FRA(lofphi)
      ,CHFp_CONST_FRA(phi)
      ,CHFp_CONST_FRA(diagn)
      ,CHFp_CONST_FRA(lower)
      ,CHFp_CONST_FRA(centr)
      ,CHFp_CONST_FRA(upper)
      ,CHFp_BOX(region)
      ,CHFp_CONST_INT(idir)
      ,CHFp_CONST_INT(redBlack) );

// Prototype for Fortran procedure VCDIVOP2INVERSEADD ...
//
#define FORT_VCDIVOP2INVERSEADD FORTRAN_NAME( VCDIVOP2INVERSEADD ,vcdivop2inverseadd )
void 
FORT_VCDIVOP2INVERSEADD(
      CHFp_FRA(lambda)
      ,CHFp_CONST_FRA(diagn)
      ,CHFp_CONST_FRA(centr)
      ,CHFp_BOX(region)
      ,CHFp_CONST_INT(idir) );

// Prototype for Fortran procedure VCDIVOP2GSRB ...
//
#define FORT_VCDIVOP2GSRB FORTRAN_NAME( VCDIVOP2GSRB ,vcdivop2gsrb )
void 
FORT_VCDIVOP2GSRB(
      CHFp_FRA(phi)
      ,CHFp_CONST_FRA(rhs)
      ,CHFp_CONST_FRA(lofphi)
      ,CHFp_CONST_FRA(lambda)
      ,CHFp_BOX(region)
      ,CHFp_CONST_INT(redBlack) );

// Prototype for Fortran procedure VCDIVOP2DEPOSITD ...
//
#define FORT_VCDIVOP2DEPOSITD FORTRAN_NAME( VCDIVOP2DEPOSITD ,vcdivop2depositd )
void 
FORT_VCDIVOP2DEPOSITD(
      CHFp_FRA(coarse)
      ,CHFp_CONST_FRA(fine)
      ,CHFp_BOX(b)
      ,CHFp_CONST_INT(ref_ratio)
      ,CHFp_BOX(bref) );

// Prototype for Fortran procedure VCDIVOP2DEPOSITLCU ...
//
#define FORT_VCDIVOP2DEPOSITLCU FORTRAN_NAME( VCDIVOP2DEPOSITLCU ,vcdivop2depositlcu )
void 
FORT_VCDIVOP2DEPOSITLCU(
      CHFp_FRA(coarse_lo)
      ,CHFp_FRA(coarse_up)
      ,CHFp_FRA(coarse_cr)
      ,CHFp_CONST_FRA(fine_lo)
      ,CHFp_CONST_FRA(fine_up)
      ,CHFp_CONST_FRA(fine_cr)
      ,CHFp_BOX(b)
      ,CHFp_CONST_INT(ref_ratio)
      ,CHFp_BOX(bref)
      ,CHFp_CONST_INT(idir) );

// Prototype for Fortran procedure VCDIVOP2GETFLUX ...
//
#define FORT_VCDIVOP2GETFLUX FORTRAN_NAME( VCDIVOP2GETFLUX ,vcdivop2getflux )
void 
FORT_VCDIVOP2GETFLUX(
      CHFp_FRA(flux)
      ,CHFp_CONST_FRA(phi)
      ,CHFp_CONST_FRA(lower)
      ,CHFp_CONST_FRA(centr)
      ,CHFp_CONST_FRA(upper)
      ,CHFp_BOX(fluxbox)
      ,CHFp_BOX(edgebox)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(idir) );

}

#endif
