#ifndef _WAVEMHDIBCF_F_H_
#define _WAVEMHDIBCF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure WAVEMHDSETF ...
//
#define FORT_WAVEMHDSETF FORTRAN_NAME( WAVEMHDSETF ,wavemhdsetf )
void 
FORT_WAVEMHDSETF(
      CHFp_REAL(a_smallPressure)
      ,CHFp_CONST_REAL(a_gamma) );

// Prototype for Fortran procedure WAVEMHDSETPARAMETERSF ...
//
#define FORT_WAVEMHDSETPARAMETERSF FORTRAN_NAME( WAVEMHDSETPARAMETERSF ,wavemhdsetparametersf )
void 
FORT_WAVEMHDSETPARAMETERSF(
      CHFp_CONST_REAL(a_alpha)
      ,CHFp_CONST_INT(a_pdir)
      ,CHFp_CONST_INT(a_kratio)
      ,CHFp_CONST_INT(a_waveNumber)
      ,CHFp_CONST_REAL(a_pertAmplitude) );

// Prototype for Fortran procedure WAVEMHDINITF ...
//
#define FORT_WAVEMHDINITF FORTRAN_NAME( WAVEMHDINITF ,wavemhdinitf )
void 
FORT_WAVEMHDINITF(
      CHFp_FRA(U)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure WAVEMHDBCF ...
//
#define FORT_WAVEMHDBCF FORTRAN_NAME( WAVEMHDBCF ,wavemhdbcf )
void 
FORT_WAVEMHDBCF(
      CHFp_FRA(F)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_REAL(time)
      ,CHFp_CONST_INT(lohisign)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure WAVEMHDSLOPEBCSF ...
//
#define FORT_WAVEMHDSLOPEBCSF FORTRAN_NAME( WAVEMHDSLOPEBCSF ,wavemhdslopebcsf )
void 
FORT_WAVEMHDSLOPEBCSF(
      CHFp_FRA(dW)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi) );

// Prototype for Fortran procedure WAVEMHDPHIINITF ...
//
#define FORT_WAVEMHDPHIINITF FORTRAN_NAME( WAVEMHDPHIINITF ,wavemhdphiinitf )
void 
FORT_WAVEMHDPHIINITF(
      CHFp_FRA(U)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure WAVEMHDPHIBCLOF ...
//
#define FORT_WAVEMHDPHIBCLOF FORTRAN_NAME( WAVEMHDPHIBCLOF ,wavemhdphibclof )
void 
FORT_WAVEMHDPHIBCLOF(
      CHFp_FRA(U)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure WAVEMHDPHIBCHIF ...
//
#define FORT_WAVEMHDPHIBCHIF FORTRAN_NAME( WAVEMHDPHIBCHIF ,wavemhdphibchif )
void 
FORT_WAVEMHDPHIBCHIF(
      CHFp_FRA(U)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure WAVEMHDPRIMBCF ...
//
#define FORT_WAVEMHDPRIMBCF FORTRAN_NAME( WAVEMHDPRIMBCF ,wavemhdprimbcf )
void 
FORT_WAVEMHDPRIMBCF(
      CHFp_FRA(WG)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_REAL(time)
      ,CHFp_CONST_INT(lohisign)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

}

#endif
