#if CH_LANG_CC
/*   _______              __
    / ___/ /  ___  __ _  / /  ___
   / /__/ _ \/ _ \/  V \/ _ \/ _ \
   \___/_//_/\___/_/_/_/_.__/\___/
*/
// CHOMBO Copyright (c) 2000-2004, The Regents of the University of
// California, through Lawrence Berkeley National Laboratory (subject to
// receipt of any required approvals from U.S. Dept. of Energy).  All
// rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// (1) Redistributions of source code must retain the above copyright
// notice, this list of conditions and the following disclaimer.
// (2) Redistributions in binary form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
// (3) Neither the name of Lawrence Berkeley National Laboratory, U.S.
// Dept. of Energy nor the names of its contributors may be used to endorse
// or promote products derived from this software without specific prior
// written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
// TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
// PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
// OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// You are under no obligation whatsoever to provide any bug fixes,
// patches, or upgrades to the features, functionality or performance of
// the source code ("Enhancements") to anyone; however, if you choose to
// make your Enhancements available either publicly, or directly to
// Lawrence Berkeley National Laboratory, without imposing a separate
// written license agreement for such Enhancements, then you hereby grant
// the following license: a non-exclusive, royalty-free perpetual license
// to install, use, modify, prepare derivative works, incorporate into
// other computer software, distribute, and sublicense such Enhancements or
// derivative works thereof, in binary and source code form.
//
// TRADEMARKS. Product and company names mentioned herein may be the
// trademarks of their respective owners.  Any rights not expressly granted
// herein are reserved.
//

// Constants used between C++ and Fortran to index the conserved and
// primitive variables and to know the number of each.  Also, the number
// of slopes and fluxes are defined here.
#endif

#ifndef _LGINTEGRATOR_H_
#define _LGINTEGRATOR_H_

#if (CH_SPACEDIM == 2)

#define WRHO     0
#define WVELX    1
#define WVELY    2
#define WVELZ    3
#define WBX      4
#define WBY      5
#define WBZ      6
#define WPRES    7
#define WTEMP    7
#define WC       8

#define WNUM     8
#define WSLOPE   8

#define URHO     0
#define UMOMX    1
#define UMOMY    2
#define UMOMZ    3
#define UBX      4
#define UBY      5
#define UBZ      6
#define UENG     7
#define DIVB     8
#define UFACE    9
#define VFACE   10
#define WFACE   11
#define BXFACE  12
#define BYFACE  13
#define BZFACE  14

#define UNUM     8
#define UFLUX   15

#endif

#if (CH_SPACEDIM == 3)

#define WRHO     0
#define WVELX    1
#define WVELY    2
#define WVELZ    3
#define WBX      4
#define WBY      5
#define WBZ      6
#define WPRES    7
#define WTEMP    7
#define WC       8

#define WNUM     8
#define WSLOPE   8

#define URHO     0
#define UMOMX    1
#define UMOMY    2
#define UMOMZ    3
#define UBX      4
#define UBY      5
#define UBZ      6
#define UENG     7
#define DIVB     8
#define UFACE    9
#define VFACE   10
#define WFACE   11
#define BXFACE  12
#define BYFACE  13
#define BZFACE  14

#define UNUM     8
#define UFLUX    8

#endif

#endif
