#ifndef _MHDPHYSICSF_F_H_
#define _MHDPHYSICSF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure MAGNITUDEF ...
//
#define FORT_MAGNITUDEF FORTRAN_NAME( MAGNITUDEF ,magnitudef )
void 
FORT_MAGNITUDEF(
      CHFp_FRA1(magdata)
      ,CHFp_CONST_FRA(data)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure MAXWAVESPEEDF ...
//
#define FORT_MAXWAVESPEEDF FORTRAN_NAME( MAXWAVESPEEDF ,maxwavespeedf )
void 
FORT_MAXWAVESPEEDF(
      CHFp_REAL(cmax)
      ,CHFp_CONST_FRA(U)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure CONSTOPRIMF ...
//
#define FORT_CONSTOPRIMF FORTRAN_NAME( CONSTOPRIMF ,constoprimf )
void 
FORT_CONSTOPRIMF(
      CHFp_FRA(W)
      ,CHFp_CONST_FRA(U)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure PRIMTOCONSF ...
//
#define FORT_PRIMTOCONSF FORTRAN_NAME( PRIMTOCONSF ,primtoconsf )
void 
FORT_PRIMTOCONSF(
      CHFp_FRA(U)
      ,CHFp_CONST_FRA(W)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure CHARANALYSISF ...
//
#define FORT_CHARANALYSISF FORTRAN_NAME( CHARANALYSISF ,charanalysisf )
void 
FORT_CHARANALYSISF(
      CHFp_FRA(dW)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_INT(normdir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure CHARSYNTHESISF ...
//
#define FORT_CHARSYNTHESISF FORTRAN_NAME( CHARSYNTHESISF ,charsynthesisf )
void 
FORT_CHARSYNTHESISF(
      CHFp_FRA(dW)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_INT(normdir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure CHARVALUESF ...
//
#define FORT_CHARVALUESF FORTRAN_NAME( CHARVALUESF ,charvaluesf )
void 
FORT_CHARVALUESF(
      CHFp_FRA(lambda)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_INT(normdir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure GETADWDXF ...
//
#define FORT_GETADWDXF FORTRAN_NAME( GETADWDXF ,getadwdxf )
void 
FORT_GETADWDXF(
      CHFp_FRA(adwdx)
      ,CHFp_CONST_FRA(WHalf)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_REAL(dtodx)
      ,CHFp_CONST_INT(normdir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure RIEMANNF ...
//
#define FORT_RIEMANNF FORTRAN_NAME( RIEMANNF ,riemannf )
void 
FORT_RIEMANNF(
      CHFp_FRA(Wgdnv)
      ,CHFp_CONST_FRA(WLeft)
      ,CHFp_CONST_FRA(WRight)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure GETFLUXF ...
//
#define FORT_GETFLUXF FORTRAN_NAME( GETFLUXF ,getfluxf )
void 
FORT_GETFLUXF(
      CHFp_FRA(F)
      ,CHFp_CONST_FRA(Wgdnv)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure UPDATECONSF ...
//
#define FORT_UPDATECONSF FORTRAN_NAME( UPDATECONSF ,updateconsf )
void 
FORT_UPDATECONSF(
      CHFp_FRA(U)
      ,CHFp_CONST_FRA(F)
      ,CHFp_CONST_REAL(dtbydx)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure GETRELGRADF ...
//
#define FORT_GETRELGRADF FORTRAN_NAME( GETRELGRADF ,getrelgradf )
void 
FORT_GETRELGRADF(
      CHFp_FRA1(du)
      ,CHFp_CONST_FRA1(u)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi)
      ,CHFp_BOX(centerBox) );

// Prototype for Fortran procedure DIVERGENCEBF ...
//
#define FORT_DIVERGENCEBF FORTRAN_NAME( DIVERGENCEBF ,divergencebf )
void 
FORT_DIVERGENCEBF(
      CHFp_FRA(divb)
      ,CHFp_CONST_FRA(whalf)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(Box) );

// Prototype for Fortran procedure PROJECTBFIELDF ...
//
#define FORT_PROJECTBFIELDF FORTRAN_NAME( PROJECTBFIELDF ,projectbfieldf )
void 
FORT_PROJECTBFIELDF(
      CHFp_FRA(whalf)
      ,CHFp_CONST_FRA(phi)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(Box) );

// Prototype for Fortran procedure STONECORRECTION ...
//
#define FORT_STONECORRECTION FORTRAN_NAME( STONECORRECTION ,stonecorrection )
void 
FORT_STONECORRECTION(
      CHFp_FRA(whalf)
      ,CHFp_CONST_FRA(W)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi)
      ,CHFp_BOX(box)
      ,CHFp_CONST_INT(idir)
      ,CHFp_CONST_REAL(dtbydx) );

// Prototype for Fortran procedure GRADIENTBF ...
//
#define FORT_GRADIENTBF FORTRAN_NAME( GRADIENTBF ,gradientbf )
void 
FORT_GRADIENTBF(
      CHFp_FRA(gradB)
      ,CHFp_CONST_FRA(BFLD)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(icomp)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure DIVGRADBTF ...
//
#define FORT_DIVGRADBTF FORTRAN_NAME( DIVGRADBTF ,divgradbtf )
void 
FORT_DIVGRADBTF(
      CHFp_FRA(divgradBT)
      ,CHFp_CONST_FRA(gradB)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure BFILTERF ...
//
#define FORT_BFILTERF FORTRAN_NAME( BFILTERF ,bfilterf )
void 
FORT_BFILTERF(
      CHFp_FRA(BFld)
      ,CHFp_CONST_FRA(divgradBT)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_REAL(dt)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure CONSTOPLOTF ...
//
#define FORT_CONSTOPLOTF FORTRAN_NAME( CONSTOPLOTF ,constoplotf )
void 
FORT_CONSTOPLOTF(
      CHFp_FRA(W)
      ,CHFp_CONST_FRA(U)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure INTERPOLATESOLNINTIMEF ...
//
#define FORT_INTERPOLATESOLNINTIMEF FORTRAN_NAME( INTERPOLATESOLNINTIMEF ,interpolatesolnintimef )
void 
FORT_INTERPOLATESOLNINTIMEF(
      CHFp_FRA(U)
      ,CHFp_CONST_FRA(UOld)
      ,CHFp_CONST_FRA(UNew)
      ,CHFp_BOX(box)
      ,CHFp_CONST_REAL(alpha) );

// Prototype for Fortran procedure COMPUTETEMPERATUREF ...
//
#define FORT_COMPUTETEMPERATUREF FORTRAN_NAME( COMPUTETEMPERATUREF ,computetemperaturef )
void 
FORT_COMPUTETEMPERATUREF(
      CHFp_FRA(U)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure COMPUTEVELOCITYFROMMOMENTUMF ...
//
#define FORT_COMPUTEVELOCITYFROMMOMENTUMF FORTRAN_NAME( COMPUTEVELOCITYFROMMOMENTUMF ,computevelocityfrommomentumf )
void 
FORT_COMPUTEVELOCITYFROMMOMENTUMF(
      CHFp_FRA(VEL)
      ,CHFp_CONST_FRA(U)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure COMPUTEMOMENTUMFROMVELOCITYF ...
//
#define FORT_COMPUTEMOMENTUMFROMVELOCITYF FORTRAN_NAME( COMPUTEMOMENTUMFROMVELOCITYF ,computemomentumfromvelocityf )
void 
FORT_COMPUTEMOMENTUMFROMVELOCITYF(
      CHFp_FRA(MOM)
      ,CHFp_CONST_FRA(U)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure COMPUTETEMPERATUREFROMCONSERVEDF ...
//
#define FORT_COMPUTETEMPERATUREFROMCONSERVEDF FORTRAN_NAME( COMPUTETEMPERATUREFROMCONSERVEDF ,computetemperaturefromconservedf )
void 
FORT_COMPUTETEMPERATUREFROMCONSERVEDF(
      CHFp_FRA1(TEMP)
      ,CHFp_CONST_FRA(U)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure COMPUTERHOHALF ...
//
#define FORT_COMPUTERHOHALF FORTRAN_NAME( COMPUTERHOHALF ,computerhohalf )
void 
FORT_COMPUTERHOHALF(
      CHFp_FRA1(rhoHalf)
      ,CHFp_FRA1(rho)
      ,CHFp_CONST_FRA1(dU)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_REAL(dt)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure CELLVELOCITYBYAVERAGINGFACES ...
//
#define FORT_CELLVELOCITYBYAVERAGINGFACES FORTRAN_NAME( CELLVELOCITYBYAVERAGINGFACES ,cellvelocitybyaveragingfaces )
void 
FORT_CELLVELOCITYBYAVERAGINGFACES(
      CHFp_FRA(vel)
      ,CHFp_CONST_FRA(Whalf)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure COMPUTERHSVELOCITYF ...
//
#define FORT_COMPUTERHSVELOCITYF FORTRAN_NAME( COMPUTERHSVELOCITYF ,computerhsvelocityf )
void 
FORT_COMPUTERHSVELOCITYF(
      CHFp_FRA(rhs)
      ,CHFp_CONST_FRA(vel)
      ,CHFp_CONST_FRA(dU)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_REAL(dt)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure DIFFUSIVEENERGYFLUXF ...
//
#define FORT_DIFFUSIVEENERGYFLUXF FORTRAN_NAME( DIFFUSIVEENERGYFLUXF ,diffusiveenergyfluxf )
void 
FORT_DIFFUSIVEENERGYFLUXF(
      CHFp_FRA1(eV)
      ,CHFp_CONST_FRA(Bfld)
      ,CHFp_CONST_FRA(Vel)
      ,CHFp_CONST_INT(idir)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure DIFFUSIVEENERGYTERMF ...
//
#define FORT_DIFFUSIVEENERGYTERMF FORTRAN_NAME( DIFFUSIVEENERGYTERMF ,diffusiveenergytermf )
void 
FORT_DIFFUSIVEENERGYTERMF(
      CHFp_FRA1(divEv)
      ,CHFp_FRA1(eV)
      ,CHFp_CONST_INT(idir)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure RHSTEMPERATURE ...
//
#define FORT_RHSTEMPERATURE FORTRAN_NAME( RHSTEMPERATURE ,rhstemperature )
void 
FORT_RHSTEMPERATURE(
      CHFp_FRA1(rhs)
      ,CHFp_CONST_FRA(UNew)
      ,CHFp_CONST_FRA(UOld)
      ,CHFp_CONST_FRA(dU)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_REAL(dt)
      ,CHFp_BOX(box) );

}

#endif
