#ifndef _RECONMHDIBCF_F_H_
#define _RECONMHDIBCF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure SETMHDRECON ...
//
#define FORT_SETMHDRECON FORTRAN_NAME( SETMHDRECON ,setmhdrecon )
void 
FORT_SETMHDRECON(
      CHFp_CONST_REAL(a_gamma)
      ,CHFp_CONST_REAL(a_mu)
      ,CHFp_CONST_REAL(a_eta)
      ,CHFp_CONST_REAL(a_kappa) );

// Prototype for Fortran procedure MHDRECONINIT ...
//
#define FORT_MHDRECONINIT FORTRAN_NAME( MHDRECONINIT ,mhdreconinit )
void 
FORT_MHDRECONINIT(
      CHFp_FRA(U)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure MHDRECONPARABOLICFLUXBC ...
//
#define FORT_MHDRECONPARABOLICFLUXBC FORTRAN_NAME( MHDRECONPARABOLICFLUXBC ,mhdreconparabolicfluxbc )
void 
FORT_MHDRECONPARABOLICFLUXBC(
      CHFp_FRA(F)
      ,CHFp_FRA(W)
      ,CHFp_CONST_REAL(time)
      ,CHFp_CONST_INT(lohisign)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure MHDDIFFUSIVEENERGYFLUXBCF ...
//
#define FORT_MHDDIFFUSIVEENERGYFLUXBCF FORTRAN_NAME( MHDDIFFUSIVEENERGYFLUXBCF ,mhddiffusiveenergyfluxbcf )
void 
FORT_MHDDIFFUSIVEENERGYFLUXBCF(
      CHFp_FRA(F)
      ,CHFp_FRA(W)
      ,CHFp_CONST_REAL(time)
      ,CHFp_CONST_INT(lohisign)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure MHDRECONBC ...
//
#define FORT_MHDRECONBC FORTRAN_NAME( MHDRECONBC ,mhdreconbc )
void 
FORT_MHDRECONBC(
      CHFp_FRA(F)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_REAL(time)
      ,CHFp_CONST_INT(lohisign)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure RECONMHDPRIMBCF ...
//
#define FORT_RECONMHDPRIMBCF FORTRAN_NAME( RECONMHDPRIMBCF ,reconmhdprimbcf )
void 
FORT_RECONMHDPRIMBCF(
      CHFp_FRA(WG)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_REAL(time)
      ,CHFp_CONST_INT(lohisign)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure MHDRECONSOLIDBC ...
//
#define FORT_MHDRECONSOLIDBC FORTRAN_NAME( MHDRECONSOLIDBC ,mhdreconsolidbc )
void 
FORT_MHDRECONSOLIDBC(
      CHFp_FRA(F)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_REAL(time)
      ,CHFp_CONST_INT(lohisign)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure MHDRECONSLOPEBCS ...
//
#define FORT_MHDRECONSLOPEBCS FORTRAN_NAME( MHDRECONSLOPEBCS ,mhdreconslopebcs )
void 
FORT_MHDRECONSLOPEBCS(
      CHFp_FRA(dW)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi) );

// Prototype for Fortran procedure RECONPHIINIT ...
//
#define FORT_RECONPHIINIT FORTRAN_NAME( RECONPHIINIT ,reconphiinit )
void 
FORT_RECONPHIINIT(
      CHFp_FRA(U)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure RECONPHIBCLO ...
//
#define FORT_RECONPHIBCLO FORTRAN_NAME( RECONPHIBCLO ,reconphibclo )
void 
FORT_RECONPHIBCLO(
      CHFp_FRA(U)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure RECONPHIBCHI ...
//
#define FORT_RECONPHIBCHI FORTRAN_NAME( RECONPHIBCHI ,reconphibchi )
void 
FORT_RECONPHIBCHI(
      CHFp_FRA(U)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure RECONMHDFACEMAGBCF ...
//
#define FORT_RECONMHDFACEMAGBCF FORTRAN_NAME( RECONMHDFACEMAGBCF ,reconmhdfacemagbcf )
void 
FORT_RECONMHDFACEMAGBCF(
      CHFp_FRA(F)
      ,CHFp_CONST_REAL(time)
      ,CHFp_CONST_INT(lohisign)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

}

#endif
