#ifndef _ROTORMHDIBCF_F_H_
#define _ROTORMHDIBCF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure ROTORMHDSETF ...
//
#define FORT_ROTORMHDSETF FORTRAN_NAME( ROTORMHDSETF ,rotormhdsetf )
void 
FORT_ROTORMHDSETF(
      CHFp_REAL(a_smallPressure)
      ,CHFp_CONST_REAL(a_gamma)
      ,CHFp_CONST_REAL(a_mu)
      ,CHFp_CONST_REAL(a_eta)
      ,CHFp_CONST_REAL(a_kappa) );

// Prototype for Fortran procedure ROTORMHDINITF ...
//
#define FORT_ROTORMHDINITF FORTRAN_NAME( ROTORMHDINITF ,rotormhdinitf )
void 
FORT_ROTORMHDINITF(
      CHFp_FRA(U)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure ROTORMHDPARABOLICFLUXBCF ...
//
#define FORT_ROTORMHDPARABOLICFLUXBCF FORTRAN_NAME( ROTORMHDPARABOLICFLUXBCF ,rotormhdparabolicfluxbcf )
void 
FORT_ROTORMHDPARABOLICFLUXBCF(
      CHFp_FRA(F)
      ,CHFp_FRA(W)
      ,CHFp_CONST_REAL(time)
      ,CHFp_CONST_INT(lohisign)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure ROTORMHDBCF ...
//
#define FORT_ROTORMHDBCF FORTRAN_NAME( ROTORMHDBCF ,rotormhdbcf )
void 
FORT_ROTORMHDBCF(
      CHFp_FRA(F)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_REAL(time)
      ,CHFp_CONST_INT(lohisign)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure ROTORMHDPRIMBCF ...
//
#define FORT_ROTORMHDPRIMBCF FORTRAN_NAME( ROTORMHDPRIMBCF ,rotormhdprimbcf )
void 
FORT_ROTORMHDPRIMBCF(
      CHFp_FRA(WG)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_REAL(time)
      ,CHFp_CONST_INT(lohisign)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure ROTORMHDSOLIDBCF ...
//
#define FORT_ROTORMHDSOLIDBCF FORTRAN_NAME( ROTORMHDSOLIDBCF ,rotormhdsolidbcf )
void 
FORT_ROTORMHDSOLIDBCF(
      CHFp_FRA(F)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_REAL(time)
      ,CHFp_CONST_INT(lohisign)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure ROTORMHDSLOPEBCSF ...
//
#define FORT_ROTORMHDSLOPEBCSF FORTRAN_NAME( ROTORMHDSLOPEBCSF ,rotormhdslopebcsf )
void 
FORT_ROTORMHDSLOPEBCSF(
      CHFp_FRA(dW)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(loBox)
      ,CHFp_CONST_INT(hasLo)
      ,CHFp_BOX(hiBox)
      ,CHFp_CONST_INT(hasHi) );

// Prototype for Fortran procedure ROTORMHDINITPHIF ...
//
#define FORT_ROTORMHDINITPHIF FORTRAN_NAME( ROTORMHDINITPHIF ,rotormhdinitphif )
void 
FORT_ROTORMHDINITPHIF(
      CHFp_FRA(U)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure ROTORMHDPHIBCLOF ...
//
#define FORT_ROTORMHDPHIBCLOF FORTRAN_NAME( ROTORMHDPHIBCLOF ,rotormhdphibclof )
void 
FORT_ROTORMHDPHIBCLOF(
      CHFp_FRA(U)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure ROTORMHDPHIBCHIF ...
//
#define FORT_ROTORMHDPHIBCHIF FORTRAN_NAME( ROTORMHDPHIBCHIF ,rotormhdphibchif )
void 
FORT_ROTORMHDPHIBCHIF(
      CHFp_FRA(U)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_INT(dir)
      ,CHFp_BOX(box) );

}

#endif
