/*   _______              __
    / ___/ /  ___  __ _  / /  ___
   / /__/ _ \/ _ \/  V \/ _ \/ _ \
   \___/_//_/\___/_/_/_/_.__/\___/
*/
// CHOMBO Copyright (c) 2000-2004, The Regents of the University of
// California, through Lawrence Berkeley National Laboratory (subject to
// receipt of any required approvals from U.S. Dept. of Energy).  All
// rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// (1) Redistributions of source code must retain the above copyright
// notice, this list of conditions and the following disclaimer.
// (2) Redistributions in binary form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
// (3) Neither the name of Lawrence Berkeley National Laboratory, U.S.
// Dept. of Energy nor the names of its contributors may be used to endorse
// or promote products derived from this software without specific prior
// written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
// TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
// PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
// OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// You are under no obligation whatsoever to provide any bug fixes,
// patches, or upgrades to the features, functionality or performance of
// the source code ("Enhancements") to anyone; however, if you choose to
// make your Enhancements available either publicly, or directly to
// Lawrence Berkeley National Laboratory, without imposing a separate
// written license agreement for such Enhancements, then you hereby grant
// the following license: a non-exclusive, royalty-free perpetual license
// to install, use, modify, prepare derivative works, incorporate into
// other computer software, distribute, and sublicense such Enhancements or
// derivative works thereof, in binary and source code form.
//
// TRADEMARKS. Product and company names mentioned herein may be the
// trademarks of their respective owners.  Any rights not expressly granted
// herein are reserved.
//

#ifndef _CHOMBO_VERSION_H_
#define _CHOMBO_VERSION_H_

#define CHOMBO_VERSION 1.5

//
// $Id: CHOMBO_VERSION.H,v 1.13 2005/02/02 20:09:04 bvs Exp $
//

/**
   \mainpage Chombo: Block-Structured Adaptive Mesh Refinement Library

   <a href="http://seesar.lbl.gov/anag/chombo">Chombo Web Page</a>

   <table WIDTH=640 HEIGHT=26 BORDER=0 CELLPADDING=0 CELLSPACING=0>
   <tr>
   <td WIDTH=106 BGCOLOR=#303784>&nbsp;</td>
   <td WIDTH=534 BGCOLOR=#FFEF89>
   <a NAME="What is Chombo?">What is Chombo?</a></b></td>
   </tr>
   </table><br CLEAR=ALL>

   The Chombo package provides a set of tools for implementing finite
   difference methods for the solution of partial differential equations
   on block-structured adaptively refined rectangular grids.  Both elliptic
   and time-dependent modules are included.  Support for parallel platforms
   and standardized self-describing file formats are included.

   <p>

   Chombo provides a distributed infrastructure for parallel calculations
   over block-structured, adaptively refined grids.  Chombo's design is
   uniquely flexible and accessible.  Any collaborator will be able to
   develop parallel applications to solve the partial differential equations
   in which she is interested with far shorter development times than would
   be possible without the infrastructure.  Very careful design and
   documentation allows said collaborator to enter the software at many
   levels.  She  will be able to use Chombo to investigate deep technical
   issues of adaptive mesh refinement algorithms or to simply adapt the
   example applications to solve different scientific problems.
*/


/**
 *  @defgroup chombo Chombo
 * 
 */

/** @defgroup eb EBChombo
 *  
 */


/** @defgroup mf MFChombo
 *  
 */

/**
   @ingroup macros
   The major version number of Chombo -- an integer.

   The Chombo version number has the form:

               CHOMBO_VERSION_MAJOR.CHOMBO_VERSION_MINOR
*/
#define CHOMBO_VERSION_MAJOR 1

/**
   @ingroup macros
   The minor version number of Chombo -- an integer.
*/
#define CHOMBO_VERSION_MINOR 5

#endif
