#!/bin/csh
#note the backquote
#regression.sh:  simple script to run a whole lot of chombo stuff in one configuration
#echo "usage: regression.sh directory(of script) dimension(2 or 3) debug(TRUE or FALSE) fc(fortran compiler cc (c++ compiler)"
##arguments: 
# dir       = current directory location of this file.
# dimension = 2 or 3
# debug     = TRUE or FALSE
# fc        = fortran compiler
# cc        = c++ compiler

set argc = $#argv
if ($argc != 5) then
echo "wrong number of arguments"
echo "usage: regression.sh directory(of script) dimension(2 or 3) debug(TRUE or FALSE) fc(fortran compiler cc (c++ compiler)"
exit
endif

set direct = $argv[1]
#if you think of a test for this one, put it in

set dimension = $argv[2]
if( ($dimension != 2) && ($dimension != 3) ) then

echo "dimension must be two or 3"
echo "usage: regression.sh directory(of script) dimension(2 or 3) debug(TRUE or FALSE) fc(fortran compiler cc (c++ compiler)"
exit

endif

set debug     = $argv[3]
if( ($debug != "TRUE") && ($debug != "FALSE") ) then

echo "debug must be true or false"
echo "usage: regression.sh directory(of script) dimension(2 or 3) debug(TRUE or FALSE) fc(fortran compiler cc (c++ compiler)"
exit

endif

set fcomp = $argv[4]
#if you think of a test for this one, put it in

set ccomp = $argv[5]
#if you think of a test for this one, put it in

set chomboDirect = $direct/../../../..
#files for program compilation and running output
#oh my those are long file names
set chombocomplog="$direct/complog.regression.$ccomp.$fcomp.$dimension.$debug.`/bin/date +%Y_%m_%d_%H_%M`"
set chomboexeclog="$direct/execlog.regression.$ccomp.$fcomp.$dimension.$debug.`/bin/date +%Y_%m_%d_%H_%M`"
set statuslog="$direct/status.log.regression.$ccomp.$fcomp.$dimension.$debug.`/bin/date +%Y_%m_%d_%H_%M`"

 
echo "begin regression test "  > $chomboexeclog
echo "begin regression test "  > $chombocomplog
echo "begin regression test "  > $statuslog

setenv USE_EB TRUE
setenv USE_MF TRUE

#loop through directories where examples can be found
foreach dir (`cat $direct/directory.$dimension.list`)

echo $chomboDirect/$dir   >> $chombocomplog
echo $chomboDirect/$dir   >> $statuslog
echo $chomboDirect/$dir   >> $chomboexeclog

#compile
cd   $chomboDirect/$dir; nice +19 time make -j4 all  DIM=$dimension DEBUG=$debug CXX=$ccomp FC=$fcomp >> $chombocomplog;

#run
cd   $chomboDirect/$dir; nice +19 time make run DIM=$dimension DEBUG=$debug CXX=$ccomp FC=$fcomp >> $chomboexeclog;

end



grep status  $chomboexeclog >> $statuslog
echo "regression complete " >> $statuslog

mail $CVSREPLYTO -s $statuslog < $statuslog

echo "Regression completed.  "  >> $chombocomplog
echo "Regression completed.  "  >> $chomboexeclog
exit
